package de.elisabetheckstaedt.dipl.GUI;

import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;
import java.util.ArrayList;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPanel;

import net.tinyos.matlab.MatClient;
import de.elisabetheckstaedt.dipl.common.Gesamtsystem;
import de.elisabetheckstaedt.dipl.common.Klimadatensatz;
import de.elisabetheckstaedt.dipl.common.Konfiguration;
import de.elisabetheckstaedt.dipl.common.Projekt;
import de.elisabetheckstaedt.dipl.common.Schnellkonfiguration;
import de.elisabetheckstaedt.dipl.common.Versorgungsaufgabe;
import de.elisabetheckstaedt.dipl.real.Kaeltemaschine;
import de.elisabetheckstaedt.dipl.real.Verbraucher;

/**
 * Hauptprogrammfenster
 * @author Elisabeth Eckstdt
 *
 */
public class Hauptfenster extends JFrame implements ActionListener {
	
	Projekt projekt = null;  //  @jve:decl-index=0:
	Klimadatensatz kds = null;
	Verbraucher[] verbraucher = null;
	Konfiguration konfiguration = null;

	//Fensterverwaltung
	private ArrayList Kindfenster = new ArrayList();
	Verbrauchein verbrauchereingabe = null;
	Klimadaten klimadaten = null;

	private static final long serialVersionUID = 1L;
	
	private JPanel jContentPane = null;
//	private JMenuBar jJMenuBarMenu = null;
//	private JMenu jMenuDatei = null;
	private JMenuItem jMenuItemOeffnen = null;
	private JMenuItem jMenuItemSpeichern = null;
	private JMenuItem jMenuItemSpeichernu = null;
	private JMenuItem jMenuItemBeenden = null;
//	private JMenu jMenuEinstellungen = null;
//	private JMenuItem jMenuItemVerzeichnis = null;
//	private JMenuItem jMenuItemKonstanten = null;
//	private JMenu jMenuHilfe = null;
//	private JMenuItem jMenuItemHilfe = null;
//	private JMenuItem jMenuItemAbout = null;
//	private JTextField jTextFieldName = null;
	private JLabel jLabelName = null;
	private JButton jButtonKlimadaten = null;
	private JButton jButtonVerbraucher = null;
	private JButton jButtonSchnellkonfiguration = null;
	private JButton jButtonSchnellkonfigurationD = null;
	private JButton jButtonkonfiguration = null;
	private JButton jButtonErgebnis = null;
//	private JTextPane jTextPaneKonsole = null;
	
	/**
	 * This is the default constructor
	 */
	public Hauptfenster() {
		super();
		initialize();
		this.setIconImage( new ImageIcon("icon.png").getImage() );

//		final Hauptfenster Ich = this;

		WindowListener windowListener = new WindowAdapter()
		{
			public void windowClosing(WindowEvent we)
			{
//				String[] optionen = {"Ja", "Nein"};
//				int n = JOptionPane.showOptionDialog( Ich,
//			              "Wollen sie DC/DEsign wirklich beenden?",      // Fragetext 
//			              "DC/DEsign",  // Titel 
//			              JOptionPane.YES_NO_OPTION,  //welche Schaltflche werden Standardmig angeizeigt; hier: ja, nein, Abbrechen
//			              JOptionPane.QUESTION_MESSAGE,  // Fenstertyp --> Icon 
//			              null, 
//			              optionen,
//			              optionen[0] ); //Standadbelegung (kommt bei Enter)
//				if ( n == JOptionPane.YES_OPTION )
//			    {
					Schliessen();
//			    }
//				else{}
			}
		};
		addWindowListener(windowListener);
	}

	/**
	 * This method initializes this
	 * 
	 * @return void
	 */
	private void initialize() {
		this.setSize(650, 150);
//		this.setJMenuBar(getJJMenuBarMenu());
		this.setContentPane(getJContentPane());
		this.setIconImage( new ImageIcon("icon.png").getImage() );
		this.setTitle("DC/DEsign");
		
//		FKD = new Klimadaten(this);
//		FKD.setVisible(false);
//		FV = new Verbrauchereingabe(this);
//		FV.setVisible(false);
	}
	

	
	protected void Kind_hinzufuegen(TopCustomDialog Kind)
	{
		Kindfenster.add(Kind);
	}
//
//	protected void Kind_zerstoeren(F_einzelner_Verbraucher Kind)
//	{
//		Kindfenster.remove(Kind);
//		Kind.dispose();
//	}

	
	void Schliessen()
	{
		for (int i=0; i<Kindfenster.size(); i++)
		{
			((TopCustomDialog) Kindfenster.get(i)).Schliessen();
		}
		System.exit(0);
	}

	public void actionPerformed(ActionEvent ae)
	{
		Object Quelle = ae.getSource();
		if (Quelle == jButtonVerbraucher)
		{
			getVerbrauchereingabe();
		}
		if (Quelle == jMenuItemOeffnen)
		{
//			JOptionPane.showMessageDialog( this, "Alle ungespeicherten nderungen am derzeit geffneten Projekt gehen verloren!"); 
//			JFileChooser oeffnenDialog = new JFileChooser(); //hie vorher fc
//			int state = oeffnenDialog.showOpenDialog( this ); 
//			File file = null;
//			if ( state == JFileChooser.APPROVE_OPTION ) 
//			{ 
//				file = oeffnenDialog.getSelectedFile();
//			} 
////			XStream xstream = new XStream(new DomDriver());
//			projekt = (Projekt) xstream.fromXML( Helper.txttoString(file) );
		}
		else if (Quelle == jMenuItemSpeichern)
		{
//			projekt.Speichern();
		}
		else if (Quelle == jMenuItemSpeichernu)
		{
//			String name = JOptionPane.showInputDialog( "Bitte neuen Projektnamen eingeben" );
//			Preisdaten pd = projekt.getPD();
//			Verbraucher[] vl = projekt.getVerbraucher();
//			Klimadatensatz kds = projekt.getKDS();
//			String[] konsolen = projekt.getKonsolenausgaben();
//			File[] ergebnisse = projekt.getErgebnisse();
//			projekt = new Projekt(name, vl, kds);
//			projekt.setKonsolenausgaben(konsolen);
//			projekt.setErgebnisse(ergebnisse);
//			projekt.Speichern();
		}
		else if (Quelle == jButtonKlimadaten)
		{
			getKlimadaten();
		}
		else if (Quelle == jButtonSchnellkonfiguration)
		{
			projekt = new Projekt("Chemnitz", verbraucher, kds);
			Schnellkonfiguration SchnellZ = new Schnellkonfiguration(projekt, this);
			konfiguration = SchnellZ;
//			SchnellZ.f_kz_zahl.setVisible(false);
			SchnellZ.kz_zuordnen(1);
			Verbraucher[][] verbraucher_kzs = new Verbraucher[1][];
			verbraucher_kzs[0] = verbraucher;
			SchnellZ.kzs_aufspalten(verbraucher_kzs);
			SchnellZ.tn_zuordnen(1, 0);
			SchnellZ.f_tn_zuordnung[0].namen_kzs[0] = "TS 0 SN 0";
			SchnellZ.km_anzahl(0,verbraucher_kzs);
			//Kltemaschinen anlegen und zuordnen
			Object[] rgw = new Versorgungsaufgabe(verbraucher, kds).maschinenauswahl_auto(0);
			int maschinenzahl = ((double[])rgw[1]).length;
			double[] nennleistungen = new double[maschinenzahl];
			for (int j=0; j<maschinenzahl; j++)
			{
				nennleistungen[j] = ((double[])rgw[1])[j];
			}
			SchnellZ.km_anzahl_fertig(0, maschinenzahl, (double[][]) rgw[2], nennleistungen);
			for (int j=0; j<maschinenzahl; j++)
			{
				SchnellZ.kms[0][j] = ((Kaeltemaschine[]) rgw[0])[j];
			}
			SchnellZ.geschlossen = SchnellZ.geschlossen + (maschinenzahl - 1);
			SchnellZ.f_kz_zuordnung.namen_kzs[0] = "TS 0";
			SchnellZ.kms_anlegen();
		}
		else if (Quelle == jButtonSchnellkonfigurationD)
		{
			projekt = new Projekt("Chemnitz", verbraucher, kds);
			int anzahl = verbraucher.length;
			Schnellkonfiguration SchnellD = new Schnellkonfiguration(projekt, this);
			konfiguration = SchnellD;
//			SchnellD.f_kz_zahl.setVisible(false);
			SchnellD.kz_zuordnen(anzahl);
			Verbraucher[][] verbraucher_kzs = new Verbraucher[anzahl][1];
			for (int i=0; i<anzahl; i++)
			{
				verbraucher_kzs[i][0] = verbraucher[i];
			}
			SchnellD.kzs_aufspalten(verbraucher_kzs);
			Verbraucher[][] verbraucher_tns = new Verbraucher[1][];
			for (int i=0; i<anzahl; i++)
			{
				SchnellD.tn_zuordnen(1, i);
				SchnellD.f_tn_zuordnung[i].namen_kzs[0] = "TS " + i + " SN 0";
				verbraucher_tns[0] = verbraucher_kzs[i];
				SchnellD.km_anzahl(i,verbraucher_tns);
				//Kltemaschinen anlegen und zuordnen
				Verbraucher[] vk = new Verbraucher[1];
				vk[0] = verbraucher[i];
				Object[] rgw = new Versorgungsaufgabe(vk, kds).maschinenauswahl_auto(0);
				int maschinenzahl = ((double[])rgw[1]).length;
				double[] nennleistungen = new double[maschinenzahl];
				for (int j=0; j<maschinenzahl; j++)
				{
					nennleistungen[j] = ((double[])rgw[1])[j];
				}
				SchnellD.km_anzahl_fertig(i, maschinenzahl, (double[][]) rgw[2], nennleistungen);
				for (int j=0; j<maschinenzahl; j++)
				{
					SchnellD.kms[i][j] = ((Kaeltemaschine[]) rgw[0])[j];
				}
				SchnellD.geschlossen = SchnellD.geschlossen + (maschinenzahl - 1);
				SchnellD.f_kz_zuordnung.namen_kzs[i] = "TS " + i;
			}
			SchnellD.geschlossen = SchnellD.geschlossen + (anzahl - 1);
			SchnellD.kms_anlegen();
		}
		else if (Quelle == jButtonkonfiguration)
		{
			projekt = new Projekt("Chemnitz", verbraucher, kds);
			try
			{
				MatClient mc = new MatClient();
				mc.sendCommand("", null);
				konfiguration = new Konfiguration(projekt, this);
			}
			catch (Exception e)
			{
				System.err.println("Verbindung zu Matlab nicht mglich. Es werden keine Diagramme ausgegeben.");
				konfiguration = new Schnellkonfiguration(projekt, this);
			}
		}
		else if (Quelle == jButtonErgebnis)
		{
			berechnen(konfiguration.lv);
			Werteingabe werteingabe = new Werteingabe(this, konfiguration.lv);
			werteingabe.setVisible(true);
		}
		else if (Quelle == jMenuItemBeenden)
		{
			Schliessen();
		}
	}
	
	void berechnen(Gesamtsystem gesamtsystem)
	{
		gesamtsystem.verbrauecheBerechnen(new Versorgungsaufgabe(projekt.getVerbraucher(), projekt.getKDS()));
		gesamtsystem.Kosten(projekt.getPD());
		gesamtsystem.Investition();
		gesamtsystem.XMLoutflach(projekt.getPD());
		gesamtsystem.XMLout(projekt);
		gesamtsystem.zeitschritte_out();
		gesamtsystem.verbraucher_out();
	}
	
	void konfig_freischalten()
	{
		if (!(kds == null) && !(verbraucher == null))
		{
			jButtonkonfiguration.setEnabled(true);
			jButtonSchnellkonfiguration.setEnabled(true);
			jButtonSchnellkonfigurationD.setEnabled(true);
		}
	}
	
	public void ergebnis_freischalten()
	{
		jButtonErgebnis.setEnabled(true);
	}
	
	private Verbrauchein getVerbrauchereingabe()
	{
		if (verbrauchereingabe == null)
		{
			Kind_hinzufuegen(verbrauchereingabe = new Verbrauchein(this));
		}
		verbrauchereingabe.setVisible(true);
		return verbrauchereingabe;
	}
	
	private Klimadaten getKlimadaten()
	{
		if (klimadaten == null)
		{
			Kind_hinzufuegen(new Klimadaten(this));
		}
		return klimadaten;
	}

	/**
	 * This method initializes jPanelInhalt
	 * 
	 * @return javax.swing.JPanel
	 */
	private JPanel getJContentPane() {
		if (jContentPane == null) {
			
			jContentPane = new JPanel();
			jContentPane.setLayout(new GridBagLayout());
			
			GridBagConstraints gridBagConstraints22 = new GridBagConstraints();
			gridBagConstraints22.fill = GridBagConstraints.BOTH;
			gridBagConstraints22.gridy = 0;
			gridBagConstraints22.weightx = 1.0;
			gridBagConstraints22.gridwidth = 2;
			gridBagConstraints22.gridx = 1;
//			jContentPane.add(getJTextFieldName(), gridBagConstraints22);
			
			GridBagConstraints gridBagConstraints13 = new GridBagConstraints();
			gridBagConstraints13.gridx = 0;
			gridBagConstraints13.gridy = 0;
			jLabelName = new JLabel();
			jLabelName.setText("Projektname");
			jLabelName.setEnabled(false);
//			jContentPane.add(jLabelName, gridBagConstraints13);
			
			GridBagConstraints gridBagConstraints4 = new GridBagConstraints();
			gridBagConstraints4.gridx = 1;
			gridBagConstraints4.fill = GridBagConstraints.BOTH;
			gridBagConstraints4.gridy = 4;
			jContentPane.add(getJButtonSchnellkonfigurationD(), gridBagConstraints4);
			
			GridBagConstraints gridBagConstraints12 = new GridBagConstraints();
			gridBagConstraints12.fill = GridBagConstraints.BOTH;
			gridBagConstraints12.gridy = 6;
			gridBagConstraints12.weightx = 1.0;
			gridBagConstraints12.weighty = 1.0;
			gridBagConstraints12.gridwidth = 3;
			gridBagConstraints12.gridx = 0;
//			jContentPane.add(getJTextPaneKonsole(), gridBagConstraints12);
			
			GridBagConstraints gridBagConstraints11 = new GridBagConstraints();
			gridBagConstraints11.gridx = 0;
			gridBagConstraints11.gridwidth = 3;
			gridBagConstraints11.fill = GridBagConstraints.BOTH;
			gridBagConstraints11.gridy = 5;
			jContentPane.add(getJButtonErgebnis(), gridBagConstraints11);
		
			GridBagConstraints gridBagConstraints = new GridBagConstraints();
//			gridBagConstraints.insets = new Insets(5, 23, 2, 2);
			gridBagConstraints.gridx = 0;
			gridBagConstraints.gridy = 3;
			gridBagConstraints.gridwidth = 3;
			gridBagConstraints.fill = GridBagConstraints.BOTH;
			jContentPane.add(getjButtonVerbraucher(), gridBagConstraints);
			
			GridBagConstraints gridBagConstraints1 = new GridBagConstraints();
//			gridBagConstraints1.insets = new Insets(5, 3, 2, 2);
			gridBagConstraints1.gridy = 2;
			gridBagConstraints1.gridwidth = 3;
			gridBagConstraints1.fill = GridBagConstraints.BOTH;
			gridBagConstraints1.gridx = 0;
			jContentPane.add(getJButtonKlimadaten(), gridBagConstraints1);
			
			GridBagConstraints gridBagConstraints2 = new GridBagConstraints();
//			gridBagConstraints2.insets = new Insets(5, 3, 2, 24);
			gridBagConstraints2.gridy = 4;
			gridBagConstraints2.fill = GridBagConstraints.BOTH;
			gridBagConstraints2.gridx = 0;
			jContentPane.add(getJButtonSchnellkonfiguration(), gridBagConstraints2);
			
			GridBagConstraints gridBagConstraints3 = new GridBagConstraints();
//			gridBagConstraints3.insets = new Insets(3, 15, 227, 49);
			gridBagConstraints3.gridy = 4;
			gridBagConstraints3.fill = GridBagConstraints.BOTH;
			gridBagConstraints3.gridx = 2;
			jContentPane.add(getJButtonkonfiguration(), gridBagConstraints3);

		}
		return jContentPane;
	}
	/**
	 * This method initializes ButtonVerbraucher	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getjButtonVerbraucher()
	{
		if (jButtonVerbraucher == null)
		{
			jButtonVerbraucher = new JButton();
			jButtonVerbraucher.setText("Verbraucher bearbeiten...");
			jButtonVerbraucher.addActionListener(this);
		}
		return jButtonVerbraucher;
	}

	/**
	 * This method initializes jButtonKlimadaten	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonKlimadaten() {
		if (jButtonKlimadaten == null) {
			jButtonKlimadaten = new JButton();
			jButtonKlimadaten.setText("Klimadaten bearbeiten...");
			jButtonKlimadaten.addActionListener(this);
		}
		return jButtonKlimadaten;
	}

	/**
	 * This method initializes jButtonSchnellkonfiguration	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonSchnellkonfiguration() {
		if (jButtonSchnellkonfiguration == null) {
			jButtonSchnellkonfiguration = new JButton();
			jButtonSchnellkonfiguration.setText("Schnellkonfiguration Zentral");
			jButtonSchnellkonfiguration.addActionListener(this);
			jButtonSchnellkonfiguration.setEnabled(false);
		}
		return jButtonSchnellkonfiguration;
	}

	/**
	 * This method initializes jButtonkonfiguration	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonkonfiguration() {
		if (jButtonkonfiguration == null) {
			jButtonkonfiguration = new JButton();
			jButtonkonfiguration.setText("Benutzerdefinierte Konfiguration...");
			jButtonkonfiguration.addActionListener(this);
			jButtonkonfiguration.setEnabled(false);
		}
		return jButtonkonfiguration;
	}

//	/**
//	 * This method initializes jJMenuBarMenu	
//	 * 	
//	 * @return javax.swing.JMenuBar	
//	 */
//	private JMenuBar getJJMenuBarMenu() {
//		if (jJMenuBarMenu == null) {
//			jJMenuBarMenu = new JMenuBar();
//			jJMenuBarMenu.add(getJMenuDatei());
//			jJMenuBarMenu.add(getJMenuEinstellungen());
//			jJMenuBarMenu.add(getJMenuHilfe());
//		}
//		return jJMenuBarMenu;
//	}

//	/**
//	 * This method initializes jMenuDatei	
//	 * 	
//	 * @return javax.swing.JMenu	
//	 */
//	private JMenu getJMenuDatei() {
//		if (jMenuDatei == null) {
//			jMenuDatei = new JMenu();
//			jMenuDatei.setName("");
//			jMenuDatei.setText("Datei");
//			jMenuDatei.setEnabled(false);
//			jMenuDatei.add(getJMenuItemOeffnen());
//			jMenuDatei.add(getJMenuItemSpeichernu());
//			jMenuDatei.add(getJMenuItemSpeichern());
//			jMenuDatei.add(getJMenuItemBeenden());
//		}
//		return jMenuDatei;
//	}

//	/**
//	 * This method initializes jMenuItemSpeichernu	
//	 * 	
//	 * @return javax.swing.JMenuItem	
//	 */
//	private JMenuItem getJMenuItemSpeichernu() {
//		if (jMenuItemSpeichernu == null) {
//			jMenuItemSpeichernu = new JMenuItem();
//			jMenuItemSpeichernu.setText("Speichern unter...");
//			jMenuItemSpeichernu.addActionListener(this);
//		}
//		return jMenuItemSpeichernu;
//	}
//
//	/**
//	 * This method initializes jMenuItemOeffnen	
//	 * 	
//	 * @return javax.swing.JMenuItem	
//	 */
//	private JMenuItem getJMenuItemOeffnen() {
//		if (jMenuItemOeffnen == null) {
//			jMenuItemOeffnen = new JMenuItem();
//			jMenuItemOeffnen.setText("ffnen...");
//			jMenuItemOeffnen.addActionListener(this);
//		}
//		return jMenuItemOeffnen;
//	}
//
//	/**
//	 * This method initializes jMenuItemBeenden	
//	 * 	
//	 * @return javax.swing.JMenuItem	
//	 */
//	private JMenuItem getJMenuItemBeenden() {
//		if (jMenuItemBeenden == null) {
//			jMenuItemBeenden = new JMenuItem();
//			jMenuItemBeenden.setText("Beenden");
//			jMenuItemBeenden.addActionListener(this);
//		}
//		return jMenuItemBeenden;
//	}
//
//	/**
//	 * This method initializes jMenuItemHilfe	
//	 * 	
//	 * @return javax.swing.JMenuItem	
//	 */
//	private JMenuItem getJMenuItemHilfe() {
//		if (jMenuItemHilfe == null) {
//			jMenuItemHilfe = new JMenuItem();
//			jMenuItemHilfe.setText("Hilfe");
//		}
//		return jMenuItemHilfe;
//	}
//
//	/**
//	 * This method initializes jMenuHilfe	
//	 * 	
//	 * @return javax.swing.JMenu	
//	 */
//	private JMenu getJMenuHilfe() {
//		if (jMenuHilfe == null) {
//			jMenuHilfe = new JMenu();
//			jMenuHilfe.setText("Hilfe");
//			jMenuHilfe.setEnabled(false);
//			jMenuHilfe.add(getJMenuItemHilfe());
//			jMenuHilfe.add(getJMenuItemAbout());
//		}
//		return jMenuHilfe;
//	}

//	/**
//	 * This method initializes jMenuItemAbout	
//	 * 	
//	 * @return javax.swing.JMenuItem	
//	 */
//	private JMenuItem getJMenuItemAbout() {
//		if (jMenuItemAbout == null) {
//			jMenuItemAbout = new JMenuItem();
//			jMenuItemAbout.setText("About");
//		}
//		return jMenuItemAbout;
//	}

	/**
	 * This method initializes jButtonErgebnis	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonErgebnis() {
		if (jButtonErgebnis == null) {
			jButtonErgebnis = new JButton();
			jButtonErgebnis.setText("Ergebnis...");
			jButtonErgebnis.addActionListener(this);
			jButtonErgebnis.setEnabled(false);
		}
		return jButtonErgebnis;
	}

//	/**
//	 * This method initializes jTextPaneKonsole	
//	 * 	
//	 * @return javax.swing.JTextPane	
//	 */
//	private JTextPane getJTextPaneKonsole() {
//		if (jTextPaneKonsole == null) {
//			jTextPaneKonsole = new JTextPane();
//			jTextPaneKonsole.setName("");
//			jTextPaneKonsole.setText("");
//		}
//		return jTextPaneKonsole;
//	}

	/**
	 * This method initializes jButtonSchnellkonfigurationD	
	 * 	
	 * @return javax.swing.JButton	
	 */
	private JButton getJButtonSchnellkonfigurationD() {
		if (jButtonSchnellkonfigurationD == null) {
			jButtonSchnellkonfigurationD = new JButton();
			jButtonSchnellkonfigurationD.setText("Schnellkonfiguration Dezentral");
			jButtonSchnellkonfigurationD.addActionListener(this);
			jButtonSchnellkonfigurationD.setEnabled(false);
		}
		return jButtonSchnellkonfigurationD;
	}

//	/**
//	 * This method initializes jTextFieldName	
//	 * 	
//	 * @return javax.swing.JTextField	
//	 */
//	private JTextField getJTextFieldName() {
//		if (jTextFieldName == null) {
//			jTextFieldName = new JTextField();
//			jTextFieldName.setText("Chemnitz2015");
//			jTextFieldName.setEnabled(false);
//		}
//		return jTextFieldName;
//	}
//
//	/**
//	 * This method initializes jMenuEinstellungen	
//	 * 	
//	 * @return javax.swing.JMenu	
//	 */
//	private JMenu getJMenuEinstellungen() {
//		if (jMenuEinstellungen == null) {
//			jMenuEinstellungen = new JMenu();
//			jMenuEinstellungen.setText("Einstellungen");
//			jMenuEinstellungen.setEnabled(false);
//			jMenuEinstellungen.add(getJMenuItemVerzeichnis());
//			jMenuEinstellungen.add(getJMenuItemKonstanten());
//		}
//		return jMenuEinstellungen;
//	}

//	/**
//	 * This method initializes jMenuItemVerzeichnis	
//	 * 	
//	 * @return javax.swing.JMenuItem	
//	 */
//	private JMenuItem getJMenuItemVerzeichnis() {
//		if (jMenuItemVerzeichnis == null) {
//			jMenuItemVerzeichnis = new JMenuItem();
//			jMenuItemVerzeichnis.setText("Arbeitsverzeichnis setzen");
//		}
//		return jMenuItemVerzeichnis;
//	}
//
//	/**
//	 * This method initializes jMenuItemKonstanten	
//	 * 	
//	 * @return javax.swing.JMenuItem	
//	 */
//	private JMenuItem getJMenuItemKonstanten() {
//		if (jMenuItemKonstanten == null) {
//			jMenuItemKonstanten = new JMenuItem();
//			jMenuItemKonstanten.setText("Konstanten bearbeiten...");
//		}
//		return jMenuItemKonstanten;
//	}
//
//	/**
//	 * This method initializes jMenuItemSpeichern	
//	 * 	
//	 * @return javax.swing.JMenuItem	
//	 */
//	private JMenuItem getJMenuItemSpeichern() {
//		if (jMenuItemSpeichern == null) {
//			jMenuItemSpeichern = new JMenuItem();
//			jMenuItemSpeichern.setText("Speichern");
//			jMenuItemSpeichern.addActionListener(this);
//		}
//		return jMenuItemSpeichern;
//	}

	public Projekt getProjekt() {
		return projekt;
	}

	public void setProjekt(Projekt projekt) {
		this.projekt = projekt;
	}

}  //  @jve:decl-index=0:visual-constraint="10,10"
