package de.elisabetheckstaedt.dipl.common;

import java.util.Date;

import de.elisabetheckstaedt.dipl.GUI.F_6_KM_Spez;
import de.elisabetheckstaedt.dipl.GUI.F_5_KM_Zahl;
import de.elisabetheckstaedt.dipl.GUI.F_1_TS_Zahl;
import de.elisabetheckstaedt.dipl.GUI.F_2_TS_Zuordnung;
import de.elisabetheckstaedt.dipl.GUI.F_3_SN_Zahl;
import de.elisabetheckstaedt.dipl.GUI.F_4_SN_Zuordnung;
import de.elisabetheckstaedt.dipl.GUI.Hauptfenster;
import de.elisabetheckstaedt.dipl.real.Kaeltemaschine;
import de.elisabetheckstaedt.dipl.real.Teilsystem;
import de.elisabetheckstaedt.dipl.real.Pumpe;
import de.elisabetheckstaedt.dipl.real.Rohrnetz;
import de.elisabetheckstaedt.dipl.real.Subnetz;
import de.elisabetheckstaedt.dipl.real.Verbraucher;

/**
 * Diese Klasse enthlt den Ablaufcode fr die Erstellung der Systemkonfiguration wie im Handbuch 
 * Abschnitt 5 beschrieben. Sie speichert smtliche Zwischenwerte, verwaltet die Fenster und legt 
 * am Ende die Systemkonfiguration in Form eines Objektes der Klasse Konfiguration an.
 * @author Elisabeth Eckstdt
 */
public class Konfiguration {
	
//	final Projekt projekt; //gesetzt in init()
	final public Gesamtsystem lv;
	protected final Versorgungsaufgabe va; //init()
	final Verbraucher[] verbraucher_gesamt; //1. Ebene & Inhalt init()
	int zahl_kz = 0; //kz_zuordnen()
	public Teilsystem[] kzs = null; //1. Ebene kz_zuordnen(); Inhalt kzs_aufspalten()
	public Verbraucher[][] verbraucher_kzs = null; //(1. Ebene kz_zuordnen()), Inhalt kzs_aufspalten()[][]
	int[] zahl_tn = null; //1. Ebene kz_zurodnen(), Inhalt tn_zuordnen()
	Verbraucher[][][] verbraucher_tns = null; //1. Ebene kz_zuordnen(), Inhalt km_anzahl()[][]
	Subnetz[][] tns = null; //1. Ebene kz_zurodnen ;2. Ebene & Inhalt km_anzahl()
	public Kaeltemaschine[][] kms = null; //1. Ebene kz_zuordnen(), 2. Ebene km_anzahl_fertig(), Inhalt vom Fenster F_6_KM_Spez
	int[] zahl_km = null;  //1. Ebene kz_zuordnen(), Inhalt km_spezifizieren();
	double[][][] leistungsanteile_km = null; //
	double[][] maschinenleistungen = null;
	
	//Fenster
	public Hauptfenster hauptfenster = null;
	public F_1_TS_Zahl f_kz_zahl = null; //init()
	public F_2_TS_Zuordnung f_kz_zuordnung = null; //kz_zuordnen()
	public F_3_SN_Zahl[] f_tn_zahl = null; //1. Ebene kz_zuordnen(); Inhalt tn_anzahl()
	public F_4_SN_Zuordnung[] f_tn_zuordnung = null; //1. Ebene kz_zuordnen(), Inhalt tn_zuordnen()
	public F_5_KM_Zahl[] f_km_zahl = null; //1. Ebene kz_zuordnen(), Inhalt km_anzahl()
	public F_6_KM_Spez[][] f_km_spez = null;  //1. Ebene kz_zuordnen()
	
	int geoeffnet = 0;
	public int geschlossen = 0;
	
	public Konfiguration(Projekt projekt, Hauptfenster hauptfenster)
	{
		this.hauptfenster = hauptfenster;
//		this.projekt = projekt;
		this.va = new Versorgungsaufgabe(projekt.getVerbraucher(), projekt.getKDS());
		verbraucher_gesamt = projekt.getVerbraucher();
		lv = new Gesamtsystem(projekt, "Berechnung " + new Date().toString());
		start();
	}
	
	protected void start()
	{
		try {
			Zeichnen.alle_Verbraucher(verbraucher_gesamt, "Kontrollausgabe: Koordinaten aller Verbraucher");
			System.out.println("Verbraucher gezeichnet");
			Thread.sleep(3000);
			Zeichnen.geordnete_lastgaenge(va.getVerbraucher(), va.getKlimadatensatz());
		} catch (Exception e) {			e.printStackTrace();		}
		f_kz_zahl = new F_1_TS_Zahl(this, verbraucher_gesamt.length);
		f_kz_zahl.setVisible(true);
		
	}
	
	/**
	 * wird gerufen wenn Fenster F_1_TS_Zahl fertig
	 * @param anzahl
	 */
	public void kz_zuordnen(int anzahl)
	{
		f_kz_zahl.setVisible(false);
		zahl_kz = anzahl;
		zahl_tn = new int[anzahl];
		kzs = new Teilsystem[zahl_kz];
		tns = new Subnetz[anzahl][];
		verbraucher_tns = new Verbraucher[zahl_kz][][];
		leistungsanteile_km = new double[zahl_kz][][];
		f_km_zahl = new F_5_KM_Zahl[zahl_kz];
		kms = new Kaeltemaschine[zahl_kz][];
		f_tn_zahl = new F_3_SN_Zahl[zahl_kz];
		f_tn_zuordnung = new F_4_SN_Zuordnung[zahl_kz];
		f_kz_zuordnung = new F_2_TS_Zuordnung(this, verbraucher_gesamt, zahl_kz);
		f_km_spez = new F_6_KM_Spez[zahl_kz][];
		maschinenleistungen = new double[zahl_kz][];
		zahl_km = new int[zahl_kz];
		f_kz_zuordnung.setVisible(true);
	}
	
	
	/**
	 * wird gerufen wenn Fenster F_2_TS_Zuordnung fertig
	 */
	public void kzs_aufspalten(Verbraucher[][] verbraucher_kzs)
	{
		f_kz_zuordnung.setVisible(false);
		this.verbraucher_kzs = verbraucher_kzs;
		for (int i=0; i<zahl_kz; i++)
		{
			try {
				Zeichnen.alle_Verbraucher(verbraucher_kzs[i], "Kontrollausgabe: Koordinaten der Verbraucher in Teilsystem " + i);
			} catch (Exception e) {				e.printStackTrace();			}
//			Zeichnen.geordnete_lastgaenge_alle(
//					f_kz_zuordnung.verbraucher_kzs[i], 
//					va.getKlimadatensatz(), 
//					"geordnete Lastgnge " + f_kz_zuordnung.namen_kzs[i]);
//			Zeichnen.lastgaenge_alle(
//					f_kz_zuordnung.verbraucher_kzs[i], 
//					va.getKlimadatensatz(), 
//					"Lastgnge " + f_kz_zuordnung.namen_kzs[i]);
			tn_anzahl(i);
		}
	}
	
	/**
	 * wird von kzs_aufspalten() mehrfach gerufen, (fr mehrere Teilsysteme)
	 * @param kznummer
	 */
	public void tn_anzahl(int kznummer)
	{
		geoeffnet++;
		f_tn_zahl[kznummer] = new F_3_SN_Zahl(this, kznummer, verbraucher_kzs[kznummer].length);
		f_tn_zahl[kznummer].setVisible(true);
	}
	
	/**
	 * wird gerufen wenn Fenster F_3_SN_Zahl fertig
	 */
	public void tn_zuordnen(int anzahl, int kznummer)
	{
		geschlossen++;
		f_tn_zahl[kznummer].setVisible(false);
		zahl_tn[kznummer] = anzahl;
		geoeffnet++;
		f_tn_zuordnung[kznummer] = new F_4_SN_Zuordnung(this, anzahl, kznummer, verbraucher_kzs[kznummer],f_kz_zuordnung.namen_kzs[kznummer]);
		f_tn_zuordnung[kznummer].setVisible(true);
	}
	
	/**
	 * wird gerufen wenn Fenster F_4_SN_Zuordnung fertig
	 */
	public void km_anzahl(int kznummer, Verbraucher[][] verbraucher_tns)
	{
		geschlossen++;
		f_tn_zuordnung[kznummer].setVisible(false);
		this.verbraucher_tns[kznummer] = verbraucher_tns;
		tns[kznummer] = new Subnetz[zahl_tn[kznummer]];
		for (int i=0; i<zahl_tn[kznummer]; i++)
		{
			Pumpe pumpe = new Pumpe("Subnetz " + new Integer(i).toString());
			Rohrnetz rohrnetz = new Rohrnetz("Subnetz " + new Integer(i).toString(),"KMR");
			Verbraucher[] verbraucher = this.verbraucher_tns[kznummer][i];
			String name = f_tn_zuordnung[kznummer].namen_kzs[i];
			tns[kznummer][i] = new Subnetz(name, pumpe, rohrnetz, verbraucher);
		}
		
		double[] kaelteleistung = new Versorgungsaufgabe(verbraucher_kzs[kznummer], va.getKlimadatensatz()).Lastgang();
		geoeffnet++;
		try {
			Zeichnen.geordneter_lastgang(verbraucher_kzs[kznummer], va.getKlimadatensatz(),"Kontrollausgabe: geordneter Lastgang Teilsystem " + kznummer);
		} catch (Exception e) {			e.printStackTrace();		}
		f_km_zahl[kznummer] = new F_5_KM_Zahl(this, kznummer, kaelteleistung);
		f_km_zahl[kznummer].setVisible(true);
	}
	
	/**
	 * gerufen wenn F_5_KM_Zahl fertig, Spezifikationsfenster werden vom F_5_KM_Zahl direkt geffnet
	 * @param kznummer
	 * @param anzahl
	 * @param leistungsanteile
	 * @param nennleistungen
	 */
	public void km_anzahl_fertig(int kznummer, int anzahl, double[][] leistungsanteile, double[] nennleistungen)
	{
		geschlossen++;
		f_km_zahl[kznummer].setVisible(false);
		kms[kznummer] = new Kaeltemaschine[anzahl];
		zahl_km[kznummer] = anzahl;
		geoeffnet = geoeffnet + anzahl;
		f_km_spez[kznummer] = new F_6_KM_Spez[anzahl]; 
		leistungsanteile_km[kznummer] = leistungsanteile;
		maschinenleistungen[kznummer] = nennleistungen;
	}
	
	/**
	 * wird gerufen wenn KM-spezifiziert
	 */
	public void kms_anlegen()
	{
		geschlossen++;
		if (geschlossen == geoeffnet) //alle KM_Spez-Fenster sind wieder zu
		{
			for (int i = 0; i<zahl_kz; i++)
			{
				String name = f_kz_zuordnung.namen_kzs[i];
				kzs[i] = new Teilsystem(name, kms[i], leistungsanteile_km[i], tns[i]);
				for (int j=0; j<kzs[i].getKaeltemaschinen().length; j++)
				{
					kzs[i].getKaeltemaschinen()[j].init(maschinenleistungen[i][j], kzs[i].getT_K_A());
					kzs[i].getKaeltemaschinen()[j].getRueckkuehler().init(kzs[i].getKaeltemaschinen()[j]);
				}
				kzs[i].init(va.getKlimadatensatz().getAussentemperatur());
				for (int j=0; j<kzs[i].getSubnetze().length; j++)
				{
					kzs[i].getSubnetze()[j].getRohrnetz().init(kzs[i].getOrt(), kzs[i].getSubnetze()[j].getVerbraucher());
					kzs[i].getSubnetze()[j].getPumpen().init(kzs[i].getSubnetze()[j], va.getKlimadatensatz().getAussentemperatur());
					kzs[i].getSubnetze()[j].Investition();
				}
				kzs[i].Investition();
			}
			lv.setTeilsysteme(kzs);
			lv.Investition();
			hauptfenster.ergebnis_freischalten();
		}
	}

	
	

}
