package de.elisabetheckstaedt.dipl.common;

import java.util.Arrays;

/**
 * Preisdatenobjekte speichern globale Werte zur Kostenberechnung wie Zins, Stundenlohn, Betrachtungszeitraum, 
 * Preisnderungsfaktoren, Preise fr Verbrauchsmaterialien.
 * @author Elisabeth Eckstdt
 */
public class Preisdaten {
	
	/**
	 * [a]
	 */
	private double Betrachtungszeitraum = 30;
	/**
	 * [/h] Arbeitgeberseitig
	 */
	private double Stundenlohn = 14;
	/**
	 * [1]
	 */
	private double Zinssatz = 1.05;
	/**
	 * [/kWh]
	 */
	private double Strompreis = 0.1003;
	/**
	 * [/kWh]
	 */
	private double Waermepreis = 0.0087;
	/**
	 * [/m]
	 */
	private double Wasserpreis = 1.98;
	
	/**
	 * Preisnderungsfaktor Lohn [1]
	 */
	private double paf_lohn = 1.033;
	
	/**
	 * Preisnderungsfaktor Energie [1]
	 */
	private double paf_energie = 1.03; //Konstante lt. VDI 2067 Bl.1 S.17
	
	/**
	 * Preisnderungsfaktor Investitionen [1]
	 */
	private double paf_invest = 1.027; //Konstante laut VDI 2067 Blatt 1 S.17

	public double[] getStrompreis()
	{
		double[] array = new double[8760];
		Arrays.fill(array,Strompreis);
		return array;
	}
	public double[] getWaermepreis()
	{
		double[] array = new double[8760];
		Arrays.fill(array,Waermepreis);
		return array;
	}
	public double[] getWasserpreis()
	{
		double[] array = new double[8760];
		Arrays.fill(array,Wasserpreis);
		return array;
	}
	public double getBetrachtungszeitraum() {
		return Betrachtungszeitraum;
	}
	public double getPaf_energie() {
		return paf_energie;
	}
	public double getPaf_invest() {
		return paf_invest;
	}
	public double getPaf_lohn() {
		return paf_lohn;
	}
	public double getStundenlohn() {
		return Stundenlohn;
	}
	public double getZinssatz() {
		return Zinssatz;
	}
	public void setBetrachtungszeitraum(double betrachtungszeitraum) {
		Betrachtungszeitraum = betrachtungszeitraum;
	}
	public void setPaf_energie(double paf_energie) {
		this.paf_energie = paf_energie;
	}
	public void setPaf_invest(double paf_invest) {
		this.paf_invest = paf_invest;
	}
	public void setPaf_lohn(double paf_lohn) {
		this.paf_lohn = paf_lohn;
	}
	public void setStrompreis(double strompreis) {
		Strompreis = strompreis;
	}
	public void setStundenlohn(double stundenlohn) {
		Stundenlohn = stundenlohn;
	}
	public void setWaermepreis(double waermepreis) {
		Waermepreis = waermepreis;
	}
	public void setWasserpreis(double wasserpreis) {
		Wasserpreis = wasserpreis;
	}
	public void setZinssatz(double zinssatz) {
		Zinssatz = zinssatz;
	}
	

}
