package de.elisabetheckstaedt.dipl.real;

import java.util.Arrays;

/**
 * reprsentiert Verbraucher der Charakteristik Brogebude
 * @author Elisabeth Eckstdt
 */
public class Buero extends Verbraucher_k {
	
	/**
	 * Konstruktor<p>
	 * setzt Waermedurchgangswert 0.51, Raumsolltemperatur 20, Grund- 10, Nutzlast 22, Last- und Nutzfaktor (beide gleich)
	 */
	public Buero(String name, double[] ort, double nutzflaeche, double vorlauftemperatur) {
		super(name,ort,nutzflaeche,vorlauftemperatur);
		Waermedurchgangswert = 0.51; //beispielhafter Wert fr Ziegel 24 cm + 5cm Dmmung in W/m/K
		Raumsolltemperatur = 20;
		Grundlast = 10; //W/m tritt immer auf
		Nutzlast = 22; //W/m tritt auf wenn das Gebude genutzt wird
		double[][] Nutzfa = new double[3][24];
		double[][] Lastfa = new double[3][24];
		Arrays.fill(Nutzfa[0],0,6,0); //Wochentag 0-6
		Arrays.fill(Nutzfa[0],7,16,1);
		Arrays.fill(Nutzfa[0],17,23,0);
		Arrays.fill(Nutzfa[1],0,23,0); //Samstag
		Arrays.fill(Nutzfa[2],0,23,0); //Sonn- & Feiertag
		Lastfa = Nutzfa;
		
		setLastf(Lastfa);
		setNutzf(Nutzfa);
		
	} 
	public String Verbraucherart()
	{
		return "Buero";
	}
	
	
}
