package de.elisabetheckstaedt.dipl.real;

import java.util.Arrays;

/**
 * reprsentiert Verbraucher mit der Charakteristik Hotel
 * @author Elisabeth Eckstdt
 */
public class Hotel extends Verbraucher_k {

	/**
	 * Konstruktor<p>
	 * setzt Waermedurchgangswert 0.3, Raumsolltemperatur 22, Grund- 10, Nutzlast 25, Last- 1 und Nutzfaktor 1
	 */
	public Hotel(String name, double[] ort, double nutzflaeche, double vorlauftemperatur) {
		super(name,ort,nutzflaeche,vorlauftemperatur);
		Waermedurchgangswert = 0.3;
		Raumsolltemperatur = 22;
		Grundlast = 10; //W/m tritt immer auf
		Nutzlast = 25; //W/m tritt auf wenn das Gebude genutzt wird

		double[][] Nutzfa = new double[3][24];
		double[][] Lastfa = new double[3][24];
		Arrays.fill(Nutzfa[0],0,23,1); //Wochentag
		Arrays.fill(Nutzfa[1],0,23,1); //Samstag
		Arrays.fill(Nutzfa[2],0,23,1); //Sonn- & Feiertag
		Lastfa = Nutzfa;
		setLastf(Lastfa);
		setNutzf(Nutzfa);
	
		
	} 
	public String Verbraucherart()
	{
		return "Hotel";
	}
	
}
