package de.elisabetheckstaedt.dipl.real;

import java.util.Arrays;

import de.elisabetheckstaedt.dipl.common.Klimadatensatz;

/**
 * gehren nur an Kompaktanlagen heran (Definition: Kompaktanlage = luftgekhlte Anlage)
 * @author Elisabeth Eckstdt
 */
public class Luftrueckkuehler extends Rueckkuehler{

	public Luftrueckkuehler(String name) {
		super(name);
	}

	/**
	 * setzt Hilfsantriebe = 0, da Stromverbrauch ist im schlechteren epsilon der Anlage enthalten
	 * ruft RK.init()
	 * @param km
	 */
	public void init(Kompaktanlage km)
	{
		super.init(km);
		Hilfsantriebe = 0;
	}
	
	/**
	 * ist null, da bei Anlage inklusive
	 */
	protected void Investition() {
		Investition = 0;
	}

	/**
	 * ist null
	 * @param Kuehlleistung
	 * @param kds
	 */
	public void Stromverbrauch(double[] Kuehlleistung, Klimadatensatz kds) {
		Arrays.fill(Stromverbrauch,0);
	}
	public String getBauteilart()
	{
		return "Luftrueckkuehler";
	}

}
