package de.elisabetheckstaedt.dipl.real;

import java.util.Arrays;

/**
 * reprsentiert Verbraucher mit Charakteristik "Einkaufsgebude"
 * @author Elisabeth Eckstdt
 */
public class Shopping extends Verbraucher_k {

	/**
	 * setzt WDW 0.6, RST 20, Grundlast 15, Nutzlast 30
	 * @param name
	 * @param ort
	 * @param nutzflaeche
	 * @param vorlauftemperatur
	 */
	public Shopping(String name, double[] ort, double nutzflaeche, double vorlauftemperatur) {
		super(name,ort,nutzflaeche,vorlauftemperatur);
		Waermedurchgangswert = 0.6;
		Raumsolltemperatur = 20;
		Grundlast = 15; //W/m tritt immer auf
		Nutzlast = 30; //W/m tritt auf wenn das Gebude genutzt wird

		//Nutzfaktor
		double[][] Nutzfa = new double[3][24];
		double[][] Lastfa = new double[3][24];
		Arrays.fill(Nutzfa[0],0,7,0); //Wochentag
		Arrays.fill(Nutzfa[0],8,20,1);
		Arrays.fill(Nutzfa[0],21,23,0);
		Arrays.fill(Nutzfa[1],0,7,0); //Samstag
		Arrays.fill(Nutzfa[1],8,20,1);
		Arrays.fill(Nutzfa[1],21,23,0);
		Arrays.fill(Nutzfa[2],0,23,0); //Sonn- & Feiertag
		//Lastfa
		Arrays.fill(Lastfa[0],0,7,0.1); //Wochentag
		Arrays.fill(Lastfa[0],8,20,1);
		Arrays.fill(Lastfa[0],21,23,0.1);
		Arrays.fill(Lastfa[1],0,7,0.1); //Samstag
		Arrays.fill(Lastfa[1],8,20,1);
		Arrays.fill(Lastfa[1],21,23,0.1);
		Arrays.fill(Lastfa[2],0,23,0.1); //Sonn- & Feiertag
		setNutzf(Nutzfa);
		setLastf(Lastfa);
		
	} 
	public String Verbraucherart()
	{
		return "Shopping";
	}
	
}
